<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Manage_kasir extends MY_Controller{
    //put your code here
    private $breadcrumb_history  = array();

    public function __construct()
    {
        parent::__construct();
        $this->load->model('manage_kasir_model');
        $this->load->library('helper');
    }    
    
    public function index() {
        $data['message'] = $this->session->flashdata('status');

        $this->load->view('design/header');
        $this->load->view('kasir/managekasirview', $data);
        $this->load->view('design/footer');
    }
    
    public function get_weekly_report($IdKasir = 0){
        $this->manage_kasir_model->is_mingguan = TRUE;

        if (!empty($this->input->get('p'))) {
            $this->session->set_userdata('operation_id', $this->input->get('p'));
        }

        if (!empty($this->session->userdata('operation_id'))) {
            $current_operation = $this->session->userdata('operation_id');
        }else{ // if load page for the first time
            $current_operation = $this->manage_kasir_model->get_latest_weekly_period();
        }

        $kasir_downline_list = $this->manage_kasir_model->get_kasir_downline($IdKasir);

        $this->add_remove_breadcrumb($IdKasir);

        $operation_list = $this->helper->format_weekly_date($this->manage_kasir_model->get_weekly_operation_list());        

        $table_data["downline_lst"] = $kasir_downline_list;
        $data["kasir"] = $this->manage_kasir_model->get_data_kasir($IdKasir);
        $data["breadcrumb_lst"] = $this->session->userdata('my_bread');
        $data["operation_lst"] = $operation_list;
        $data["controller_name"] = 'get_weekly_report';
        $data["tingkat_level"] = count($data["breadcrumb_lst"]);
        $data["IdKasir"] = $IdKasir;
        $data["operation_id"] = $current_operation;

        $this->load->view('design/header');
        if ($IdKasir == 0 || $data["tingkat_level"] == 1){
            echo "1";
            $table_data["downline_lst"] = $this->manage_kasir_model->get_sm($this->session->userdata('loggedIn')['userId']);
            $this->render_common_table('weekly_report_view', 'hasil_coin_super_master', $data, $table_data);
        }
        else if ($data["tingkat_level"] == 2) {
            echo "2";
            $table_data["downline_lst"] = $this->manage_kasir_model->get_ms($IdKasir);
            // print_r($table_data["downline_lst"]);
            $this->render_common_table('weekly_report_view', 'hasil_coin_master', $data, $table_data);
        }
        else if ($data["tingkat_level"] == 3) {
            echo "3";
            $table_data["downline_lst"] = $this->manage_kasir_model->get_ag($IdKasir);
            $this->render_common_table('weekly_report_view', 'hasil_coin_agent', $data, $table_data);
        }
        else if ($data["tingkat_level"] == 4) {
            $table_data["downline_lst"] = $this->manage_kasir_model->get_weekly_player($IdKasir)['result'];
            
            $this->load->view('kasir/weekly_report_view', $data);
            $this->load->view('kasir/player_table_view', $table_data);
        }

        $this->load->view('design/footer');
    }

    public function get_kasir_downline($IdKasir = 0){
        if (!empty($this->input->get('p'))) {
            $this->session->set_userdata('operation_id', $this->input->get('p'));
        }

        if (!empty($this->session->userdata('operation_id'))) {
            $current_operation = $this->session->userdata('operation_id');
        }else{ // if load page for the first time
            $current_operation = $this->manage_kasir_model->get_latest_period();
        }

        $kasir_downline_list = $this->manage_kasir_model->get_kasir_downline($IdKasir);

        $this->add_remove_breadcrumb($IdKasir);

        $operation_list = $this->helper->format_date($this->manage_kasir_model->get_daily_operation_list());        

        $table_data["downline_lst"] = $kasir_downline_list;
        $data["kasir"] = $this->manage_kasir_model->get_data_kasir($IdKasir);
        $data["breadcrumb_lst"] = $this->session->userdata('my_bread');
        $data["operation_lst"] = $operation_list;
        $data["controller_name"] = 'get_kasir_downline';
        $data["tingkat_level"] = count($data["breadcrumb_lst"]);
        $data["IdKasir"] = $IdKasir;
        $data["operation_id"] = $current_operation;

        $this->load->view('design/header');
        if ($IdKasir == 0 || $data["tingkat_level"] == 1){
            $table_data["downline_lst"] = $this->manage_kasir_model->get_sm($this->session->userdata('loggedIn')['userId']);
            $this->render_common_table('managekasirview', 'hasil_coin_super_master', $data, $table_data);
        }
        else if ($data["tingkat_level"] == 2) {
            $table_data["downline_lst"] = $this->manage_kasir_model->get_ms($IdKasir);
            $this->render_common_table('managekasirview', 'hasil_coin_master', $data, $table_data);
        }
        else if ($data["tingkat_level"] == 3) {
            $table_data["downline_lst"] = $this->manage_kasir_model->get_ag($IdKasir);
            $this->render_common_table('managekasirview', 'hasil_coin_agent', $data, $table_data);
        }
        else if ($data["tingkat_level"] == 4) {
            $table_data["downline_lst"] = $this->manage_kasir_model->get_player($IdKasir)['result'];
            $this->load->view('kasir/managekasirview', $data);
            $this->load->view('kasir/player_table_view', $table_data);
        }

        $this->load->view('design/footer');
    }

    public function render_common_table($render_page ,$variable_src, $data, $table_data){
        $table_data["variable_src"] = $variable_src;
        $this->load->view('kasir/'.$render_page, $data);
        $this->load->view('kasir/common_table_view', $table_data);
    }

    public function add_remove_breadcrumb($IdKasir){
        // Cek jika baru buka halaman atau sudah klik downline
        // Cek jika user klik user sendiri.
        if ($IdKasir == 0 || $IdKasir == $this->session->userdata('loggedIn')['userId']) {
            // Reset breadcrumb array
            $this->session->unset_userdata('my_bread');
            $newdata = array(
                    'tingkat_level'     => 0,
                    'id_kasir'          => $this->session->userdata('loggedIn')['userId'],
                    'user_name'         => $this->session->userdata('loggedIn')['username']
            );
            array_push($this->breadcrumb_history, $newdata);
            $this->session->set_userdata('my_bread', $this->breadcrumb_history);
        }

        $search_result = array_search($IdKasir, array_column($this->session->userdata('my_bread'), 'id_kasir'));

        // Support breadcrumb back navigation
        if ($search_result > 0) {
            $array = $this->session->userdata('my_bread');
            unset($array[$search_result + 1]);
            unset($array[$search_result + 2]);
            $this->session->set_userdata('my_bread', $array);
        }

        // Add breadcrumb to session array
        if ($IdKasir != 0 && $search_result < 1 
            && $IdKasir != $this->session->userdata('loggedIn')['userId']) {
            $current_level = count($this->session->userdata('my_bread'));

            $this->breadcrumb_history = $this->session->userdata('my_bread');

            $newdata = array(
                    'tingkat_level'     => $current_level,
                    'id_kasir'          => $IdKasir,
                    'user_name'         => $this->manage_kasir_model->get_kasir_by_id($IdKasir)[0]->Nama
            );

            array_push($this->breadcrumb_history, $newdata);
            
            $this->session->set_userdata('my_bread', $this->breadcrumb_history);
            $current_level++;
        }
    }
}
