<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Users extends MY_Controller{
    //put your code here
    public function __construct()
    {
        parent::__construct();
        $this->load->model('user_model');
    }    
    
    public function index() {
        $user_list = '';

        if ($this->session->userdata('loggedIn')['level'] == 1) {
            // Jika login sebagai master, cari agen dibawahya
            $data = array(
                'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                'level' => 2
            );

            $user_list = $this->user_model->get_agen($data);
            $player_list = $this->user_model->get_player($data);
        }elseif ($this->session->userdata('loggedIn')['level'] == 2) {
            // Jika login sebagai agen, ambil sub agen dibawahnya
            $data = array(
                'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                'level' => 3
            ); 

            $user_list = $this->user_model->get_anak_agen($data);
            $player_list = $this->user_model->get_player($data);
        }else{
            $data = array(
                'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            );

            $player_list = $this->user_model->get_player($data);
        }

        // Jika login sebagai sub agen, ambil user dibawahnya

        $data["message"] = $this->session->flashdata('status');
        $data["error"] = $this->session->flashdata('error');
        $data["user_lst"] = $user_list;
        $data["player_lst"] = $player_list;

        $this->load->view('design/header');
        $this->load->view('users/index', $data);
        $this->load->view('design/footer');
    }
    
    public function blank_page() {
        $this->load->view('design/header');
        $this->load->view('users/blank_page');
        $this->load->view('design/footer');
    }

    public function my_profile_page() {
        $this->load->view('design/header');
        $this->load->view('users/my_profile_page');
        $this->load->view('design/footer');
    }
    public function message_page() {
        $this->load->view('design/header');
        $this->load->view('users/message_page');
        $this->load->view('design/footer');
    }

    public function change_password_page() {

        $data = array(
            'user_id' => $this->session->userdata('loggedIn')['userId'],
            'username' => $this->session->userdata('loggedIn')['username'],
            'level' => $this->session->userdata('loggedIn')['level']
        );

        if($_POST) {
            $post_data = array(
                'current_password' => $this->input->post('oldPassword'),
                'new_password' => $this->input->post('newPassword'),
                'username' => $data['username'],
                'confirm_password' => $this->input->post('confirmNewPassword')
            );

            $this->form_validation->set_rules('oldPassword', 'Password Sekarang', 'required|min_length[6]|max_length[20]');
            $this->form_validation->set_rules('newPassword', 'Password Baru', 'required|min_length[6]|max_length[20]');
            $this->form_validation->set_rules('confirmNewPassword', 'Konfirmasi Password Baru', 'required|matches[newPassword]');

            $verify_result = $this->login_database->verify_password($post_data);
            // print_r($verify_result);
            // return;

            if ($verify_result != TRUE) {
                $this->session->set_flashdata('error', 'Password lama salah');
            }

            if ($this->form_validation->run() == FALSE){

                $this->session->set_flashdata('error', 'Validasi data error');

            } else {
                if ($verify_result == TRUE) {
                    $result_query = $this->login_database->ganti_password($post_data);

                    if ($result_query == TRUE) {
                        $this->session->set_flashdata('status_success', 'Ganti password berhasil!');
                    }
                }
            }
            redirect(base_url().'users/change_password_page');
        }

        $this->load->view('design/header');
        $this->load->view('users/change_password_page');
        $this->load->view('design/footer');
    }

    /*
    public function history_game_page() {

        $data = array(
                    'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                    'level' => $this->session->userdata('loggedIn')['level']
                ); 

        if($_POST) {

        }else{
            $data["operation_lst"] = $this->user_model->get_operation_list();
            // if login == master, langsung keluarkan semua players
             if ($this->session->userdata('loggedIn')['level'] == 1) {

             }

            // If login == agen
              if ($this->session->userdata('loggedIn')['level'] == 2) {
                $data["player_lst"] = $this->user_model->get_subagen_and_players($data);
            }
        }

        // print_r($data);
        $this->load->view('design/header');
        $this->load->view('users/history_game_page', $data);
        $this->load->view('design/footer');
    }
    */

    public function history_game_saldo_page() {

        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'level' => $this->session->userdata('loggedIn')['level']
        ); 

        if($_POST) {

        }else{
            $data["operation_lst"] = $this->user_model->get_operation_list();
            // if login == master, langsung keluarkan semua players
             if ($this->session->userdata('loggedIn')['level'] == 1) {

             }

            // If login == agen
              if ($this->session->userdata('loggedIn')['level'] == 2) {
                $data["player_lst"] = $this->user_model->get_subagen_and_players($data);
            }
        }

        $this->load->view('design/header');
        $this->load->view('users/history_game_saldo_page', $data);
        $this->load->view('design/footer');
    }

    public function login_history_page() {

        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'level' => $this->session->userdata('loggedIn')['level']
        ); 

        if($_POST) {

        }else{
            $data["operation_lst"] = $this->user_model->get_operation_list();
            // if login == master, langsung keluarkan semua players
             if ($this->session->userdata('loggedIn')['level'] == 1) {

             }

            // If login == agen
              if ($this->session->userdata('loggedIn')['level'] == 2) {
                $data["player_lst"] = $this->user_model->get_subagen_and_players($data);
            }
        }

        $this->load->view('design/header');
        $this->load->view('users/login_history_page', $data);
        $this->load->view('design/footer');
    }

    public function transfer_pemain(){
        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'level' => $this->session->userdata('loggedIn')['level']
        ); 

        if($_POST) {

        }else{
            // if login == master, langsung keluarkan semua players
             if ($this->session->userdata('loggedIn')['level'] == 1) {

             }

            // If login == agen
              if ($this->session->userdata('loggedIn')['level'] == 2) {
                $data["player_lst"] = $this->user_model->get_subagen_and_players($data);
            }
        }

        $data["operation_lst"] = $this->user_model->get_operation_list();
        
        $this->load->view('design/header');
        $this->load->view('users/transfer_pemain', $data);
        $this->load->view('design/footer');
    }

    public function rollingan_harian(){
        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'level' => $this->session->userdata('loggedIn')['level']
        ); 

        if ($data['level'] == 3) {
            $data["player_lst"] = $this->user_model->get_player($data);
        }else{
            $data["subagen_lst"] = $this->user_model->get_subagen_and_players($data);
        }
        
        $data["operation_lst"] = $this->user_model->get_operation_list();
        
        $this->load->view('design/header');
        $this->load->view('users/rollingan_harian', $data);
        $this->load->view('design/footer');
    }

    public function rollingan_range_hari(){
        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'level' => $this->session->userdata('loggedIn')['level']
        ); 

        $data["operation_lst"] = $this->user_model->get_operation_list();
        
        $this->load->view('design/header');
        $this->load->view('users/rollingan_range_hari', $data);
        $this->load->view('design/footer');
    }

    public function rollingan_global(){
        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'level' => $this->session->userdata('loggedIn')['level']
        );

        // TODO: (1) aktifkan kembali
        // if ($data['level'] == 3) {
        //     $data["player_lst"] = $this->user_model->get_player($data);
        // }else{
        //     $data["subagen_lst"] = $this->user_model->get_subagen_and_players($data);
        // }

        $data['operation_max_min'] = $this->user_model->operation_max_min();

        $this->load->view('design/header');
        $this->load->view('users/rollingan_global', $data);
        $this->load->view('design/footer');
    }

    public function deposit(){
        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'username' => $this->session->userdata('loggedIn')['username'],
            'level' => $this->session->userdata('loggedIn')['level']
        );

        // $data["kasiraccount_lst"] = $this->user_model->find_kasir_account($data);
        // $data["player_lst"] = array();
        $data['agen_lst'] = $this->user_model->get_all_agen($data);

        if ($_POST) {

        }
        
        $this->load->view('design/header');
        $this->load->view('users/deposit', $data);
        $this->load->view('design/footer');
    }

    public function get_all_agen($data){
        $data = array(
            'id_kasir_induk' => $data,
        );

        $result = $this->user_model->get_all_agen($data);

        echo json_encode($result);
    }

    public function get_grup($subagenId){
        $result = $this->user_model->get_grup($subagenId);

        echo json_encode($result);
    }

    public function deposit_search($agenId, $subagenId, $dateFrom, $dateTo){
        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'level' => $this->session->userdata('loggedIn')['level']
        );

        $search_data = array(
            'deposit_date_from' => $dateFrom,
            'deposit_date_to' => $dateTo,
            'agen_id' => $agenId,
            'subagen_id' => $subagenId            
        );

        $search_data['tipe_deposit'] = 1;
        $data["deposit_in"] = $this->user_model->find_deposit_in($search_data);

        $search_data['tipe_deposit'] = 9;
        $data["deposit_out"] = $this->user_model->find_deposit_in($search_data);

        $data["isi_coin"] = $this->user_model->find_isi_coin($search_data);

        $data["cancel_credit"] = $this->user_model->find_cancel_deposit($search_data);

        // print_r(json_encode($data["cancel_credit"]));
        // return;
        // $data["cancel_credit"];

        echo json_encode($data);
    }

    public function find_kasiraccount_player($data){
        echo json_encode($this->user_model->find_kasiraccount_player($data));
    }

    public function find_rollingan_global($data = ''){
        $data = array(
            'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
            'id_level' => $this->session->userdata('loggedIn')['level']
        );
        $search_data = [];

        // cari player langsung dibawah agen
        $player_list = $this->user_model->get_player_account_flatten($data);

        $search_data['id_account'] = $player_list;

        echo json_encode($this->user_model->find_rollingan_global($search_data));
    }

    public function find_rollingan_harian($id_operation = FALSE, $id_agen = FALSE){
        if ($id_operation != FALSE && $id_agen != FALSE) {
            $data = array(
                    'id_operation' => $id_operation,
                    'id_kasir' => $id_agen,
                    'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                ); 
            
            echo json_encode($this->user_model->find_rollingan_harian($data));
        }else{
            echo 'no data';
        }
    }

    // Rollingan range harian hanya bisa melihat anak dibawahnya.
    // Level 1: bisa melihat semua agen dan sub agen. (DONE)
    // Level 2: bisa melihat sub agen dibawahnya, subtotal berdasarkan subagen, dropdown player list.
    // Level 3: bisa melihat user (player) dibawahnya
    public function find_rollingan_harian_range($id_operation_from = FALSE, 
        $id_operation_to = FALSE, $master_modal_kasir_induk = ''){

        if ($id_operation_from != FALSE && $id_operation_to != FALSE) {
            $data = array(
                'id_operation_from' => $id_operation_from,
                'id_operation_to' => $id_operation_to,
                'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                'id_level' => $this->session->userdata('loggedIn')['level'],
            );

            if ($master_modal_kasir_induk != '') {
                $data['id_kasir_induk'] = $master_modal_kasir_induk;
                $data['id_level'] = 3;
                echo $this->find_rollingan_level3($data);
                return; // STOP
            }


            //Khusus ag88
            // if ($data['id_kasir_induk'] == 1 && APP_NAME == '88Tangkas') {

                // Cari semua akun master atau level 1
                // get_all_masterid_flatten
                // echo json_encode($this->user_model->get_all_masterid_flatten());
                
                // echo json_encode($this->user_model->find_rollingan_range_sum($data));
            // }

            if ($data['id_level'] == 1) { 
                // print_r( $data);
                echo json_encode($this->user_model->find_rollingan_range_sum($data));
                
            }else if($data['id_level'] == 2){ 

                // Untuk agen, bisa lihat subagen saja, player tidak usah
                // get list subagen dulu, query dipisah karena tidak bisa campur
                $subagen_lst = $this->user_model->get_all_subagen($data);

                // Tambah ID kasir induk karena bisa ada player langsung dibawah AG
                array_push($subagen_lst, $data['id_kasir_induk']);

                echo json_encode($this->user_model->find_rollingan_range_sum_lv2($data, $subagen_lst));
            }else if($data['id_level'] == 3){ 
                // Untuk subagen, bisa lihat player
                echo json_encode($this->user_model->find_rollingan_range_sum_lv3($data));
            }
            
        }else{
            echo 'no data';
        }
    }

    public function find_rollingan_harian_range_master($master_id = FALSE, $id_operation_from = FALSE, 
        $id_operation_to = FALSE, $master_modal_kasir_induk = ''){
        if ($this->session->userdata('loggedIn')['userId'] != 1) {
            return;
        }

        if ($id_operation_from != FALSE && $id_operation_to != FALSE) {
            $master_id_list = $this->user_model->get_all_master_list();
            $data = array(
                'master_id_list' => $master_id_list,
                'id_operation_from' => $id_operation_from,
                'id_operation_to' => $id_operation_to,
                'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                'id_level' => $this->session->userdata('loggedIn')['level'],
            );

            if ($master_modal_kasir_induk != '') {
                $data['id_kasir_induk'] = $master_modal_kasir_induk;
                $data['id_level'] = 3;
                echo $this->find_rollingan_level3($data);
                return; // STOP
            }
            // print_r($master_id_list);
            $temp = array();
            foreach ($master_id_list as $key => $value) {
                $data['id_kasir_induk'] = $value->IdKasir;
                // $temp[$key] = $this->user_model->find_rollingan_range_sum_master($data);
                $temp[$value->Nama] = $this->user_model->find_rollingan_range_sum_master($data);
                // echo $value->IdKasir;
            }
            // print_r($temp);
            $return_array = array('data'=>$temp);

            echo json_encode($return_array);
            // foreach ($temp as $key => $value) {
                
            // }

            // echo json_encode($temp);

            //Khusus ag88
            // if ($data['id_kasir_induk'] == 1 && APP_NAME == '88Tangkas') {

                // Cari semua akun master atau level 1
                // get_all_masterid_flatten
                // echo json_encode($this->user_model->get_all_masterid_flatten());
                
                // echo json_encode($this->user_model->find_rollingan_range_sum($data));
            // }

            if ($data['id_level'] == 1) { 
                // print_r( $data);
                // echo json_encode($this->user_model->find_rollingan_range_sum_master($data));
                
            }else if($data['id_level'] != 1){ 
                // RETURN ERROR
            }
            
        }else{
            echo 'no data';
        }
    }

    // Khusus untuk modal yang di call dari akun master
    public function find_rollingan_level3($data){
        return json_encode($this->user_model->find_rollingan_range_sum_lv3($data));
    } 

    public function ci_test_query(){
        $data['id_kasir_induk'] = 4020;
        $data['id_operation_from'] = 4663;
        $data['id_operation_to'] = 4664;
        echo json_encode($this->user_model->get_agen_join());
        // echo $this->db->last_query();
    }

    public function find_transfer($id){
        $data = array(
                    'id_operation' => $id,
                    'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                    'id_level' => $this->session->userdata('loggedIn')['level'],
        );

        if ($data['id_level'] == 2) {
            $data['subagen_lst'] = $this->user_model->get_all_subagen($data);
        }
        
        echo json_encode($this->user_model->find_transfer_list($data));
    }

    public function find_player_machine($id){
        $data = array(
                    'id_operation' => $id,
                    'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                    'id_level' => $this->session->userdata('loggedIn')['level'],
                );

        if ($data['id_level'] == 2) {
            $data['player_lst'] = $this->user_model->get_all_subagen_dan_player($data);
        }else if($data['id_level'] == 3){
            $data['player_lst'] = $this->user_model->get_id_anak_agen_flattened($data);
        }
        
        echo json_encode($this->user_model->find_player_machine($data));
    }

    public function find_player_machine_saldo($id_operation, $player_id){
        $data = array(
                    'id_operation' => $id_operation,
                    'player_id' => $player_id,
                    'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                    'id_level' => $this->session->userdata('loggedIn')['level'],
                ); 

        echo json_encode($this->user_model->find_player_machine_saldo($data));
    }

    public function login_history($id_operation, $player_id = FALSE){
        $data = array(
                    'id_operation' => $id_operation,
                    'player_id' => $player_id,
                    'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                    'id_level' => $this->session->userdata('loggedIn')['level'],
                ); 

        if ($data['id_level'] == 2) {
            $data['player_lst'] = $this->user_model->get_all_subagen_dan_player($data);
            // print_r($data['player_lst']);
        }else if($data['id_level'] == 3){
            $data['player_lst'] = $this->user_model->get_id_anak_agen_flattened($data);
        }
        
        echo json_encode($this->user_model->login_history($data));
    }

    public function find_machine($id){
        $data = array(
                    'player_id' => $id,
                    'id_kasir_induk' => $this->session->userdata('loggedIn')['userId'],
                    'id_level' => $this->session->userdata('loggedIn')['level'],
                ); 
        
        echo json_encode($this->user_model->find_machine($data));
    }

    public function find_games($machine_id, $player_id){
        $data['machine_id'] = $machine_id;
        $data['player_id'] = $player_id;
        
        echo json_encode($this->user_model->find_games($data));
    }

    public function change_data($id){
        if($_POST) {
            //form validation
            $this->form_validation->set_rules('email', 'Email', 'required|valid_email', 
                array(
                    'required'      => 'You have not provided %s.',
                    'is_unique'     => 'This %s already exists.'
                ));

            $this->form_validation->set_rules('firstname', 'First Name', 'required');
            $this->form_validation->set_rules('lastname', 'Last Name', 'required');
            
            //error message
            if ($this->form_validation->run() == TRUE) {
                $data = array(
                    'email' => $this->input->post('email'),
                    'first_name' => $this->input->post('firstname'),
                    'last_name' => $this->input->post('lastname'),
                );
                //start transactions
                $this->db->trans_start();
                
                //change user password
                $this->user_model->update_user_data($id, $data);
                // $this->model_log->insert($this->data['menu'],'change password',$this->input->post('username'));
                
                //end transactions
                $this->db->trans_complete();
                $this->session->set_flashdata('status', 'Success update user, '.$this->input->post('username'));
            } else {
                $this->load->view('users/management/change_data_view');
                $this->session->set_flashdata('error', 'User update failed!');
            }
            redirect('users');
        }else{
            $data['content_user'] = $this->user_model->get_user_data((int)$id);
            $this->load->view('users/management/change_data_view', $data);
        }
    }

    public function change_password($id){
        if($_POST) {
            //form validation

            // $this->form_validation->set_rules('username', 'Username', 'required|alpha_dash');
            $this->form_validation->set_rules('password', 'Password', 'required');
            $this->form_validation->set_rules('password_conf', 'Confirm Password', 'required|matches[password]');
            
            //error message
            if ($this->form_validation->run() == TRUE) {
                //start transactions
                $this->db->trans_start();
                
                //change user password
                $this->user_model->change_password($id);
                // $this->model_log->insert($this->data['menu'],'change password',$this->input->post('username'));
                
                //end transactions
                $this->db->trans_complete();
                $this->session->set_flashdata('status', 'Success change user password, '.$this->input->post('username'));
            } else {
                $this->session->set_flashdata('error', 'Password change failed!');
            }
            redirect('users');
        }else{
            $data['content_user'] = $this->user_model->get_user_data((int)$id);
            $this->load->view('users/management/change_password_view', $data);
        }
    }

    public function change_status($id){
        if ($this->user_model->get_status($id) == 1) {
            // deactivate account
            $this->user_model->change_status($id, 0);
        }else{
            // activate account
            $this->user_model->change_status($id, 1);
        }
        $this->session->set_flashdata('status', 'Status change success');
        redirect('users', 'refresh');
    }


    public function lihat_anak($id){

        $data = array(
            'id_kasir_induk' => $id,
        ); 

        $user_list = $this->user_model->get_anak_agen($data);
        
        $data["user_lst"] = $user_list;
        $this->load->view('users/management/lihat_anak', $data);
    }

    public function lihat_player($id){
        $user_list = '';

        $data = array(
                'id_kasir_induk' => $id,
            );
        $player_list = $this->user_model->get_player($data);

        $data["player_lst"] = $player_list;
        $this->load->view('users/management/lihat_player', $data);
    }

    public function modal_rollingan_harian_player($id){

        $data = array(
            'id_kasir_induk' => $id,
        ); 

        // $user_list = $this->user_model->get_anak_agen($data);
        
        $this->load->view('users/management/modal_rollingan_hari_player', $data);
    }
}
