<?php 
	if(!defined('BASEPATH')) exit('No direct script access allowed');

	class Bank_model extends CI_Model
	{
		public function __construct()
		{
			parent::__construct();
			$this->load->database();
		}

		public function create_customer($data)
		{
			$result = $this->db->insert('tbl_customer', $data);
			return (boolean)$result;
		}

		public function get_all_bank()
		{
			$this->db->limit(100);
			$query = $this->db->get('bank');

			return $query->result(); //The result is an array of objects, each row = an object
		}

		public function get_bank_by()
		{
			echo $this->input->post('fromDate');
			echo $this->input->post('toDate');

			$this->db->where('Waktu >=', $this->input->post('fromDate'));
			$this->db->where('Waktu <=', $this->input->post('toDate'));
			$this->db->join('categories', 'categories.IdCategory = bank.IdCategory', 'left');
			$this->db->join('accounts', 'accounts.IdAccount = bank.IdAccount', 'left');
			$this->db->join('players', 'players.IdPlayer = accounts.IdPlayer', 'left');
			
			return $this->db->get('bank')->result();
		}

		public function update_customer_data($id)
		{
			$data = array(
		        'customer_name' 	=> $this->input->post('name'),
		        'customer_address' 	=> $this->input->post('address'),
		        'customer_contact' 	=> $this->input->post('phone'),
		        'npwp' 				=> $this->input->post('npwp'),
		        'company_name' 		=> $this->input->post('company_name'),
		        'email' 			=> $this->input->post('email'),
		        'contact_person' 	=> $this->input->post('contact_person'),
		        'notes'				=> $this->input->post('notes')
		    );

		    $this->db->where('customer_id',$id);
		    $this->db->update('tbl_customer',$data);
		}
	}
?>