<?php 
	if(!defined('BASEPATH')) exit('No direct script access allowed');

	class Manage_kasir_model extends CI_Model
	{
		var $is_mingguan;
		public function __construct()
		{
			parent::__construct();
			$this->load->database();
		}

		public function get_all_history()
		{
			$this->db->limit(100);
			$query = $this->db->get('bank_kasir');

			return $query->result(); //The result is an array of objects, each row = an object
		}

		public function get_kasir_downline($IdKasir)
		{
			if ($IdKasir == 0) {
				$user_data = $this->session->userdata('loggedIn');
				$IdKasir = $user_data['userId'];
			}

			$this->db->where('IdKasir !=',$IdKasir);
			$this->db->where('IdKasirInduk', $IdKasir);
			return $this->db->get('kasir')->result();
		}

		public function get_latest_period(){
			$this->db->order_by('IdOperation','DESC');
			$this->db->limit(1);
			$current_period = $this->db->get('operations');
			$current_period = $current_period->row();
			return $current_period->IdOperation;
		}

		public function get_latest_weekly_period(){
			$this->db->order_by('IdPeriodeMingguan','DESC');
			$this->db->limit(1);
			$current_period = $this->db->get('periode_mingguan');
			$current_period = $current_period->row();
			return $current_period->IdPeriodeMingguan;
		}

		public function get_kasir_by_id($IdKasir){
			$this->db->where('IdKasir', $IdKasir);
			return $this->db->get('kasir')->result();
		}

		public function get_data_kasir($IdKasir)
		{
			$rs = $this->db->get_where('kasir',
				array(
					'IdKasir' => $IdKasir
				)
			);
			return $rs->row();
		}

		public function get_daily_operation_list(){
			$this->db->order_by('IdOperation', 'DESC');
			return $this->db->get('operations')->result();	
		}

		public function get_weekly_operation_list(){
			$this->db->order_by('IdPeriodeMingguan', 'DESC');
			return $this->db->get('periode_mingguan')->result();	
		}

		public function get_weekly_player($IdKasir){
			$this->db->where('rollingan_mingguan_pemain.IdKasir = ', $IdKasir);
			$this->db->where('IdPeriodeMingguan', $this->session->userdata('operation_id'));

			$this->db->join('accounts', 'accounts.IdAccount = rollingan_mingguan_pemain.IdAccount', 'left');
			$this->db->join('players', 'players.IdPlayer = accounts.IdPlayer', 'left');
			$this->db->order_by("NickName", "asc"); 

			$total_hasil_coin_player = 0;
			$result = $this->db->get('rollingan_mingguan_pemain')->result();
				
			foreach($result as $item)
			{
				$hasil_coin_player = $item->CoinIn - $item->CoinOut;
				$total_hasil_coin_player += $hasil_coin_player;
			}

			return array(
				// Player List for Agent
				'result' => $result,
				// Total Coin Player
				'total_hasil_coin_player' => $total_hasil_coin_player
			);
		}

		public function get_player($IdKasir){
			$this->db->where('memplayers.IdKasir = ', $IdKasir);
			$this->db->where('IdOperation', $this->session->userdata('operation_id'));

			$this->db->join('accounts', 'accounts.IdAccount = memplayers.IdAccount', 'left');
			$this->db->join('players', 'players.IdPlayer = accounts.IdPlayer', 'left');
			$this->db->order_by("NickName", "asc"); 

			$total_hasil_coin_player = 0;
			$result = $this->db->get('memplayers')->result();
				
			foreach($result as $item)
			{
				$hasil_coin_player = $item->CoinIn - $item->CoinOut;
				$total_hasil_coin_player += $hasil_coin_player;
			}
			
			return array(
				// Player List for Agent
				'result' => $result,
				// Total Coin Player
				'total_hasil_coin_player' => $total_hasil_coin_player
			);
		}

		public function get_lowest_player($IdKasir){
			$this->db->where('IdKasir', $IdKasir);
			return $this->db->get('players')->result();
		}


		// 12 (Super Super)
		public function get_sm($id_ss)
		{
			$hasil_coin_super_master = array();
			$total_hasil_coin_super_master = 0;
			
			$this->db->where('IdKasir !=', $id_ss);
			$result = $this->db->get_where('kasir', array('IdKasirInduk' => $id_ss));
			
			foreach($result->result() as $item)
			{
				$data = $this->get_ms($item->IdKasir);	
				$hasil_coin_super_master[$item->IdKasir] = 0;
				$hasil_coin_super_master[$item->IdKasir] += $data['total_hasil_coin_master'];
				$total_hasil_coin_super_master += $hasil_coin_super_master[$item->IdKasir];
				// echo $item->IdKasir;
			}

			// print_r($result->result());
			return array(
				// List Agent for Master Agent
				'result' => $result->result(),
				// Hasil coin per Agent
				'hasil_coin_super_master' => $hasil_coin_super_master,
				// Total hasil coin Agent
				'total_hasil_coin_super_master' => $total_hasil_coin_super_master
			);
		}
			
		// 13 (Super Master)
		public function get_ms($id_sm)
		{
			$hasil_coin_master = array();
			$total_hasil_coin_master = 0;
			
			$result = $this->db->get_where('kasir',array('IdKasirInduk' => $id_sm));
			
			foreach($result->result() as $item)
			{
				// $data = $this->get_ag($item->IdKasir);
				if ($this->is_mingguan) {
					// echo "call mingguan";
					$data = $this->get_weekly_player($item->IdKasir);
				}else{
					// echo "call players";
					$data = $this->get_player($item->IdKasir);
				}
				$hasil_coin_master[$item->IdKasir] = 0;	
				$hasil_coin_master[$item->IdKasir] += $data['total_hasil_coin_player'];
				$total_hasil_coin_master += $hasil_coin_master[$item->IdKasir];
			}

			return array(
				// List Agent for Master Agent
				'result' => $result->result(),
				// Hasil coin per Agent
				'hasil_coin_master' => $hasil_coin_master,
				// Total hasil coin Agent
				'total_hasil_coin_master' => $total_hasil_coin_master
			);
		}
			
		// 14 (Master Agent)
		public function get_ag($id_ms)
		{
			
			$hasil_coin_agent = array();
			$total_hasil_coin_agent = 0;
			
			$result = $this->db->get_where('kasir', array('IdKasirInduk' => $id_ms));

			foreach($result->result() as $item)
			{
				if ($this->is_mingguan) {
					echo "call mingguan";
					$data = $this->get_weekly_player($item->IdKasir);
				}else{
					echo "call players";
					$data = $this->get_player($item->IdKasir);
				}

				$hasil_coin_agent[$item->IdKasir] = 0;
				$hasil_coin_agent[$item->IdKasir] += $data['total_hasil_coin_player'];
				$total_hasil_coin_agent += $hasil_coin_agent[$item->IdKasir];
			}
			
			return array(
				// List Agent for Master Agent
				'result' => $result->result(),
				// Hasil coin per Agent
				'hasil_coin_agent' => $hasil_coin_agent,
				// Total hasil coin Agent
				'total_hasil_coin_agent' => $total_hasil_coin_agent
			);
		}

	}
?>